#include <cassert>
#include <new>

// find the problem and fix the code

struct Stack {
    struct Node {
        int value;
        Node *prev;
    };

    ~Stack() {
        for ( Node *i = first; i; i = i->prev )
            delete i;
    }

    void push( int v ) {
        Node *n = new Node();
        n->value = v;
        n->prev = first;
        first = n;
    }

    int pop() {
        int v = first->value;
        Node *old = first;
        first = first->prev;
        delete old;
        return v;
    }

    Node *first;
};

int main() {
    try {
        Stack stack;
        stack.push( 1 );
        stack.push( 2 );
        int x = stack.pop();
        assert( x == 2 );
    } catch ( std::bad_alloc & ) { } // ignore allocation failure
}
