#include <thread>
#include <cassert>
#include <mutex>

// divine verify -std=c++14 -o nofail:malloc FILE

std::mutex lock;
using Guard = std::unique_lock< std::mutex >;

// only accessed in critical section guarded by mutex, so there is no need to
// make this variable atomic or volatile
int x;

void thread() {
    Guard guard( lock ); // automatically unlocked when function returns
    ++x;
}

int main() {
    assert( x == 0 ); // globals are initialized
    std::thread t1( thread ),
                t2( thread );
    assert( x <= 2 );
    assert( x >= 0 );
    t1.join();
    t2.join();
    assert( x == 2 );
}
